
/**************************************************************************
 *
 *  FILE            text.c
 *  MODULE OF       
 *
 *  DESCRIPTION     
 *
 *  WRITTEN BY      Sverre H. Huseby
 *
 *  MODIFICATIONS   
 *
 **************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h> /* random, srandom */

#include <shhmsg.h>
#include <xalloc.h>

#include "viking.h"

/**************************************************************************
 *                                                                        *
 *                   P R I V A T E    F U N C T I O N S                   *
 *                                                                        *
 **************************************************************************/

char *txtFGets(char *s, int n, FILE *f)
{
    int  i;
    char *ret, *p;

    while ((ret = fgets(s, n, f)) != NULL) {
        if ((p = strchr(s, '#')) != NULL)
            *p = '\0';
        while (*s && isspace(s[i = strlen(s) - 1]))
            s[i] = '\0';
        if (*s)
            break;
    }
    return ret;
}


/**************************************************************************
 *                                                                        *
 *                    P U B L I C    F U N C T I O N S                    *
 *                                                                        *
 **************************************************************************/

char **txtReadWords(const char *filename, int *n)
{
    FILE *f;
    char line[200], *tok, **ret = NULL;

    if ((f = fopen(filename, "rt")) == NULL)
        msgFatal("unable to open text-file %s\n", filename);
    *n = 0;
    while (txtFGets(line, sizeof(line), f)) {
        tok = strtok(line, " \t");
        while (tok) {
            ret = (char **) xrealloc(ret, (*n + 1) * sizeof(char *));
            ret[*n] = xstrdup(tok);
            ++*n;
            tok = strtok(NULL, " \n");
        }
    }
    fclose(f);
    msgVerbose(1, "***  read %d words from \"%s\"\n", *n, filename);
    return ret;
}

char **txtReadLines(const char *filename, int *n)
{
    FILE *f;
    char line[200], **ret = NULL;

    if ((f = fopen(filename, "rt")) == NULL)
        msgFatal("unable to open text-file %s\n", filename);
    *n = 0;
    while (txtFGets(line, sizeof(line), f)) {
        ret = (char **) xrealloc(ret, (*n + 1) * sizeof(char *));
        ret[*n] = xstrdup(line);
        ++*n;
    }
    fclose(f);
    msgVerbose(1, "***  read %d lines from \"%s\"\n", *n, filename);
    return ret;
}

char *txtRandom(char **txt, int n)
{
    int  i;
    char *ret;

    /* hoping for higher probs on an early entries */
    if (n > 1)
	i = random() % ((random() % (n - 1)) + 1);
    else
	i = 0;
    ret = txt[i];
    memcpy(&txt[i], &txt[i + 1], (n - i - 1) * sizeof(char *));
    txt[n - 1] = ret;
    return ret;
}

void txtFree(char **txt, int n)
{
    int q;

    for (q = 0; q < n; q++)
	free(txt[q]);
    free(txt);
}
