/* $Id$ */
#ifndef VIKING_H
#define VIKING_H

#define HOST "connect.vikingmud.org"
#define PORT "2001"

extern int sock;

void vikSleep(int sec);
void vikIn(char *line, int n);
void vikOut(const char *format, ...);
void vikOutQueue(int delay, const char *format, ...);
int  vikWaitForAndKeepTimeout(const char *match, char *line, int n,
			      long mstimeout);
int  vikWaitForTimeout(const char *match, long mstimeout);
void vikWaitForAndKeep(const char *match, char *line, int n);
void vikWaitFor(const char *match);
void vikAddHook(const char *match, void (*f)(char *line), int report);
void vikDelHook(const char *match, void (*f)(char *line));
void vikLogin(const char *name, const char *passwd);
void vikLogout(void);

void vikLog(const char *filename, const char *format, ...);

char **txtReadWords(const char *filename, int *n);
char **txtReadLines(const char *filename, int *n);
char *txtRandom(char **txt, int n);
void txtFree(char **txt, int n);

#endif
